import /home/steveej/src/github/NixOS/nixpkgs/default.nix {
  crossSystem = rec {
    config = "armv7l-unknown-linux-gnueabi";  
    bigEndian = false;
    arch = "arm";
    float = "hard";
    fpu = "vfpv3-d16";
    withTLS = true;
    libc = "glibc";
    platform = {
      name = "armv7l-hf-multiplatform";
      gcc = {
        arch = "armv7-a";
        fpu = "neon";
        float = "hard";
      };
      kernelMajor = "2.6"; # Using "2.6" enables 2.6 kernel syscalls in glibc.
      kernelHeadersBaseConfig = "multi_v7_defconfig";
      kernelBaseConfig = "multi_v7_defconfig";
      kernelArch = "arm";
      kernelDTB = true;
      kernelAutoModules = false;
      kernelExtraConfig = ''
         NAMESPACES y
           BTRFS_FS y
           BTRFS_FS_POSIX_ACL y
           OVERLAY_FS y
           FUSE_FS y
        '';
      kernelTarget = "zImage";
      uboot = null;
    };
    openssl.system = "linux-generic32";
    gcc = {
      arch = "armv7-a";
      fpu = "neon";
      float = "hard";
    };
  };
}
#  pkgs.config = {
#    packageOverrides = super: let self = super.pkgs; in {
#      linux_4_0 = super.linux_3_18.override {
#        kernelPatches = super.linux_3_18.kernelPatches ++ [
#          # we'll also add one of our own patches
#          { patch = ./dts.patch; name = "dts-fix"; }
#        ];
#   
#        # add "CONFIG_PPP_FILTER y" option to the set of kernel options
#        extraConfig = ''
#           HAVE_IMX_ANATOP y
#           HAVE_IMX_GPC y
#           HAVE_IMX_MMDC y
#           HAVE_IMX_SRC y
#           SOC_IMX6 y
#           SOC_IMX6Q y
#           SOC_IMX6SL y
#           PCI_IMX6 y
#           ARM_IMX6Q_CPUFREQ y
#           IMX_WEIM y
#           AHCI_IMX y
#           SERIAL_IMX y
#           SERIAL_IMX_CONSOLE y
#           I2C_IMX y
#           SPI_IMX y
#           PINCTRL_IMX y
#           PINCTRL_IMX6Q y
#           PINCTRL_IMX6SL y
#           POWER_RESET_IMX y
#           IMX_THERMAL y
#           IMX2_WDT y
#           IMX_IPUV3_CORE y
#           DRM_IMX y
#           DRM_IMX_FB_HELPER y
#           DRM_IMX_PARALLEL_DISPLAY y
#           DRM_IMX_TVE y
#           DRM_IMX_LDB y
#           DRM_IMX_IPUV3 y
#           DRM_IMX_HDMI y
#           MMC_SDHCI_ESDHC_IMX y
#           IMX_SDMA y
#           PWM_IMX y
#           DEBUG_IMX6Q_UART y
#
#           PPP_FILTER y
#        '';
#      };
#    };
#  };
